#include <bits/stdc++.h>
#define int long long
#define ll long long
#define sz(x) (int)(x).size()
#define all(x) begin(x),end(x)
#define rep(i,a,b) for (int i=(a);i<(b);i++)
using namespace std;

string to_string (string s) {return s; }
template <typename T> string to_string(T v) {
    bool first = true;
    string res = "[";
    for (const auto & x : v) {
        if (!first) res += ", ";
        first = false;
        res += to_string(x);
    }
    res += "]";
    return res;
}

void dbg_out() { cout << endl;} 
template <typename Head, typename... Tail> void dbg_out(Head H, Tail... T) {
    cout << ' ' << to_string(H);
    dbg_out(T...);
}

#ifdef DEBUG
#define dbg(...) cout << "(" << #__VA_ARGS__ << "):", dbg_out(__VA_ARGS__)
#else
#define dbg(...)
#endif

struct shortcut {
    int node, dist;
    bool operator<(shortcut other) {
        return dist < other.dist;
    }
};

vector <vector <int>> Adj;

vector <int> Parent;

vector <int> Seen;
vector <int> Queue;
int deb = 0;
vector <int> Dist;

vector <vector <shortcut>> Shortcuts;

int nbNodes, nbEdges;

void bfs(int start) {
    Seen.clear();
    Seen.resize(nbNodes);
    Queue.push_back(0);
    Dist.resize(nbNodes);
    Seen[nbNodes - 1] = 1;
    while (deb < (int)Queue.size())
    {
        int node = Queue[deb ++];
        for (int dest : Adj[node])
        {
            if (Seen[dest])
                continue;
            Parent[dest] = node;
            Queue.push_back(dest);
            Seen[dest] = 1;
            Dist[dest] = Dist[node] + 1;
        }
    }
    Shortcuts.resize(nbNodes);
    for (int i = 0; i < nbNodes; i ++)
    {
        for (int dest : Adj[i])
        {
            if (Parent[dest] != i)
                Shortcuts[i].emplace_back(dest, 1 + Dist[dest]);
        }
    }
    return;
}

priority_queue <shortcut> dfs_shortcut(int node) {
    priority_queue <shortcut> cur;

    for (int dest : Adj[node])
    {
        if (dest == Parent[node])
            continue;
        priority_queue <shortcut> act = dfs_shortcut(dest);
        
    }   
}

void solve() {
    scanf("%lld %lld", &nbNodes, &nbEdges);
    Adj.resize(nbNodes);
    Parent.resize(nbNodes);
    for (int i = 0; i < nbEdges; i ++)
    {
        int a, b;
        scanf("%lld %lld", &a, &b);
        Adj[-- a].push_back(-- b);
        Adj[b].push_back(a);
    }
    bfs(nbNodes - 1);

}

signed main(void) {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}