#include <bits/stdc++.h>
#define int long long
#define ll long long
#define sz(x) (int)(x).size()
#define all(x) begin(x),end(x)
#define rep(i,a,b) for (int i=(a);i<(b);i++)
using namespace std;

string to_string (string s) {return s; }
template <typename T> string to_string(T v) {
    bool first = true;
    string res = "[";
    for (const auto & x : v) {
        if (!first) res += ", ";
        first = false;
        res += to_string(x);
    }
    res += "]";
    return res;
}

void dbg_out() { cout << endl;} 
template <typename Head, typename... Tail> void dbg_out(Head H, Tail... T) {
    cout << ' ' << to_string(H);
    dbg_out(T...);
}

#ifdef DEBUG
#define dbg(...) cout << "(" << #__VA_ARGS__ << "):", dbg_out(__VA_ARGS__)
#else
#define dbg(...)
#endif


void solve() {
    int N;
    cin >> N;
    string s;
    cin >> s;
    int cumulW[2 * N + 1];
    int cumulR[2 * N + 1];
    cumulR[0] = 0;
    cumulW[0] = 0;
    for (int i = 0 ; i < 2 * N ; i++) {
        cumulR[i + 1] = cumulR[i];
        cumulW[i + 1] = cumulW[i];
        if (s[i] == 'W') cumulW[i + 1]++;
        else cumulR[i + 1]++;
    }

    if ((cumulW[N] % 2) || ((cumulR[2 * N] - cumulR[N]) % 2) || (cumulR[N] != cumulW[2 * N] - cumulW[N]) ) {
        cout<<"NO"<<endl;
        return;
    }

    int nbWEntre = 0;
    int nbREntre = 0;
    int idR = 0;
    int idW = N;

    int nbOpenRMin = 0;
    int nbOpenRMax = 0;

    int nbOpenWMin = 0;
    int nbOpenWMax = 0;

    for (int iR = 0 ; iR < cumulR[N] ; iR++) {
        dbg(nbOpenRMin , nbOpenRMax , nbOpenWMin , nbOpenWMax);
        while (s[idR] != 'R') {
            nbWEntre++;
            idR++;
        }
        while (s[idW] != 'W') {
            nbREntre++;
            idW++;
        }
        
        int resteW = cumulW[N] - cumulW[idR];
        int resteR = cumulR[2 * N] - cumulW[idW];

        nbOpenWMin = min(nbOpenWMin + nbWEntre , resteW);
        nbOpenWMax = min(nbOpenWMax + nbWEntre , resteW);
        nbOpenRMax = min(nbOpenRMax + nbREntre , resteR);
        nbOpenRMin = min(nbOpenRMin + nbREntre , resteR);

        dbg(nbOpenRMin , nbOpenRMax , nbOpenWMin , nbOpenWMax);

        int posRMin = (cumulW[idR] - nbOpenWMin) / 2 + nbOpenWMin;

        int posWMin = (cumulW[N] / 2) + (cumulR[idW] - cumulR[N] - nbOpenRMin);

        dbg(posRMin , posWMin);


        nbOpenWMax %= 2;
        nbOpenRMax %=2;
        int newPosMin = max(posRMin , posWMin);

        int posRMax = (cumulW[idR] - nbOpenWMax) / 2 + nbOpenWMax;
        int posWMax = (cumulW[N] / 2) + (cumulR[idW] - cumulR[N] - nbOpenRMax);

        dbg(posRMax , posWMax);
        int newPosMax = min(posRMax , posWMax);

        dbg(newPosMin , newPosMax);
        if (newPosMax < newPosMin) {
            cout<<"NO"<<endl;
            return;
        }

        nbOpenWMin -= newPosMin - posRMin;
        nbOpenRMin -= newPosMin - posWMin;

        nbOpenWMax -= posRMax - newPosMax;
        nbOpenRMin -= posWMax - newPosMax;  

        nbWEntre = 0;
        nbREntre = 0;
        idR++;
        idW++;
    }



    cout<<"YES"<<endl;
}
signed main(void) {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int N;
    cin >> N;
    for (int i = 0 ; i < N ; i++) {
        solve();
    }
}